<template>
  <div
    v-if="currentOrder"
    class="order-services-info"
  >
    <div
      class='order-step__misc-item'
      @click="toggleAccordeon('services')"
    >
      <button
        :class="{ closed: !accordeonItems.services }"
      >
        <i class="icon chevron-up" />
      </button>
      <span>Услуги</span>
    </div>
    <ExpandTransition>
      <div
        v-if="accordeonItems.services"
        class="accordeon-content"
      >
        <div class="title" style="display: block;">
          <span>Автоперевозка выделенным транспортом по маршруту</span>
          <span>{{ currentOrder.titleGeography }} </span>
        </div>
        <p
          v-if="currentOrder.contractNumber"
          class="mb40"
        >
          по договору <router-link tag="a" :to="currentOrder.contractUuid ? { name: 'contracts__detail', params: { id: currentOrder.contractUuid } } : '#'"><span class="link-style">№{{currentOrder.contractNumber}}</span></router-link> от <span>{{currentOrder.contractEffectiveD | date('DD.MM.YYYY')}}</span>
        </p>
        <div class="mb40">
          <AdditionalServices
              :order="currentOrder"
              :services="transportationServices"
              titleServices="Услуги на перевозку"
              :hideForcibly="false"
          />
        </div>
        <AdditionalServices
          v-if="isShowAdditionalServices"
          :order="currentOrder"
          :services="currentAdditionalServices"
        />
      </div>
    </ExpandTransition>
    <div
      v-if="isShowCorrections"
      class='order-step__misc-item'
      @click="toggleAccordeon('corrections')"
    >
      <button
        :class="{ closed: !accordeonItems.corrections }"
      >
        <i class="icon chevron-up" />
      </button>
      <span>Финансовые корректировки</span>
    </div>
    <ExpandTransition>
      <div
        v-if="accordeonItems.corrections && isShowCorrections"
        class="accordeon-content"
      >
        <AdditionalServices
          :order="currentOrder"
          :services="currentCorrections"
          :is-corrections="true"
        />
        <CorrectionDocument
          :order="currentOrder"
          :corrections="currentCorrections"
        />
<!--        <template v-else>-->
<!--          <div class="corrections-info">-->
<!--            <div class="corrections-info__title">Корректировки будут доступны после<br>начала работы с документами<br>(статус Инвойсирование)</div>-->
<!--            <p>Корректировки позволяют вносить изменения<br>в итоговую стоимость заказа в случае появления<br>претензионных событий</p>-->
<!--          </div>-->
<!--        </template>-->
      </div>
    </ExpandTransition>
    <div
      v-if="isShowNonFinancialAdjustment"
      class='order-step__misc-item'
      @click="toggleAccordeon('nonFinancialAdjustment')"
    >
      <button
        :class="{ closed: !accordeonItems.nonFinancialAdjustment }"
      >
        <i class="icon chevron-up" />
      </button>
      <span>Нефинансовые корректировки</span>
    </div>
    <ExpandTransition>
      <div
        v-if="accordeonItems.nonFinancialAdjustment && isShowNonFinancialAdjustment"
        class="accordeon-content"
      >
        <NonFinancialAdjustment
          :order="currentOrder"
          :corrections="currentNonFinancialAdjustment"
        />
      </div>
    </ExpandTransition>
  </div>
</template>

<script>
import AdditionalServices from "@/components/Order/orderItem/services/additionalServices"
import NonFinancialAdjustment from "@/components/Order/orderItem/services/nonFinancialAdjustment"
import CorrectionDocument from "@/components/Order/orderItem/services/CorrectionDocument"
import ExpandTransition from '@/components/ExpandTransition'
import { mapGetters } from "vuex"
import { formatNumber } from "common-components/src/helpers/common"

export default {
  name: 'OrderItemServices',
  components: {
    AdditionalServices,
    CorrectionDocument,
    ExpandTransition,
    NonFinancialAdjustment
  },
  props: {
    uuid: {
      type: String,
      default: null
    }
  },
  data () {
    return {
      accordeonItems: {
        services: true,
        corrections: true,
        nonFinancialAdjustment: true
      }
    }
  },
  computed: {
    ...mapGetters({
      order: 'order/order',
      subOrder: 'order/subOrder',
      isClicar: 'user/isClicar',
      isClient: 'user/isClient',
      isCarrier: 'user/isCarrier',
      additionalServices: 'order/additionalServices',
      nonFinancialAdjustments: 'order/nonFinancialAdjustments'
    }),
    currentOrder () {
      if (this.uuid === this.order.uuid) {
        return this.order
      } else {
        return this.subOrder[this.uuid]
      }
    },
    allowedTypesForAdditionalServices () {
      return this.currentOrder.isSuborder
        ? (['order'].includes(this.currentOrder.speciesType) && this.currentOrder.orderType === 'STANDARD') || ['legOrderService', 'shipmentPointOrderService'].includes(this.currentOrder.speciesType)
        : this.currentOrder.orderType === 'STANDARD'
    },
    isShowAdditionalServices () {
      const allowedTypes = this.currentOrder.isSuborder
        ? (['order'].includes(this.currentOrder.speciesType) && this.currentOrder.orderType === 'STANDARD') || ['legOrderService', 'shipmentPointOrderService'].includes(this.currentOrder.speciesType)
        : this.currentOrder.orderType === 'STANDARD'

      return (this.currentOrder.isEditable || this.allAdditionalServices?.length) && allowedTypes
    },
    isShowCorrections () {
      return (!this.currentOrder.isEditable || this.currentCorrections?.length) && this.allowedTypesForAdditionalServices
    },
    isShowNonFinancialAdjustment () {
      return (!this.currentOrder.isEditable || this.currentNonFinancialAdjustment?.length) && this.allowedTypesForAdditionalServices
    },
    allAdditionalServices () {
      const list = this.currentOrder && this.additionalServices ? this.additionalServices[this.currentOrder.uuid] || [] : []
      return list.filter((item) => item.serviceKind === 'ADDITIONAL_SERVICE')
    },
    transportationServices () {
      const extra = this.allAdditionalServices.filter(key => (key.title === 'Дополнительные точки' || key.title === 'Дополнительный пробег'));

      const base = {
        mainData: true,
        title: this.currentOrder.service ? this.currentOrder.service.serviceUnits[0].title : this.currentOrder.servicesList[0].title,
        service: this.currentOrder.service,
        serviceNumber: this.currentOrder.number,
        createdAt: this.currentOrder.createdAt ? this.currentOrder.createdAt : this.currentOrder.pvpDt,
        serviceUnitTitle: this.currentOrder.service ? this.currentOrder.service.serviceUnits[0].title : this.currentOrder.servicesList[0].title.split(' - ')[2],
        addServiceTotalAmount: {
          ...(this.currentOrder.orderCost || {}),
          vatValue: this.currentOrder.orderCost?.vatPrice
        },
        startAddress: this.currentOrder.startAddress ? this.currentOrder.startAddress : this.currentOrder.startPoint,
        endAddress: this.currentOrder.endAddress ? this.currentOrder.endAddress : this.currentOrder.endPoint,
        pricePerService: this.currentOrder.orderCost?.priceWithVat,
        vatValue: this.currentOrder.orderCost?.vatPrice
      };
      return [base, ...extra]
    },
    currentAdditionalServices () {
      return this.allAdditionalServices.filter(key => !(key.title === 'Дополнительные точки' || key.title === 'Дополнительный пробег'));
    },
    currentCorrections () {
      const list = this.currentOrder && this.additionalServices ? this.additionalServices[this.currentOrder.uuid] || []: []
      return list.filter((item) => item.serviceKind === 'CORRECTION')
    },
    currentNonFinancialAdjustment () {
      return this.currentOrder && this.nonFinancialAdjustments ? this.nonFinancialAdjustments[this.currentOrder.uuid] || []: []
    },
    columns () {
      const isVatPayer = this.currentOrder && this.currentOrder.servicesList && this.currentOrder.servicesList.length && Boolean(this.currentOrder.servicesList[0].vatValue)
      return [
        {
          title: 'наименование',
          key: 'title',
          width: 300
        },
        {
          title: 'География',
          key: 'geography',
          html: (data) => data.geography || '-'
        },
        {
          title: 'Единица измерения',
          key: 'unit',
          html: (data) => data.unit ? data.unit : '-'
        },
        {
          title: 'кол-во',
          key: 'count',
          html: (data) => data.count ? formatNumber(data.count) : '-'
        },
        {
          title: 'НДС, ₽',
          key: 'vatValue',
          _isEnabled: isVatPayer,
          html: (data) => data.vatValue ? formatNumber(data.vatValue, { dot: 2 }) : '-'
        },
        {
          title: 'итого без НДС, ₽',
          key: 'priceWithoutVat',
          _isEnabled: isVatPayer,
          html: (data) => data.priceWithoutVat ? formatNumber(data.priceWithoutVat, { dot: 2 }) : '-'
        },
        {
          title: isVatPayer ? 'итого, ₽' : 'итого без НДС, ₽',
          key: 'price',
          html: (data) => data.price ? formatNumber(data.price / 100, { dot: 2 }) : '-'
        }
      ]
    },
  },
  methods: {
    toggleAccordeon (value) {
      this.accordeonItems[value] = !this.accordeonItems[value]
    },
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.order-services-info {
  .title {
    display: flex;
    align-items: center;
    margin-bottom: 20px;
    @include font-mixin(16px, 20px, 600, $components-orderItem_detail_info_title_font_color, 0.4px);
    &__sub {
      margin-left: 10px;
      font-weight: normal;
      color: $gray-slate;
      span {
        font-size: 12px;
      }
    }
    span + span {
      margin-left: 5px;
    }
  }
  .text {
    @include font-mixin(14px, 16px, 400, $components-orderItem_detail_info_text_font_color, 0.4px);
  }
  .mb20 {
    margin-bottom: 20px;
  }
  .mb10 {
    margin-bottom: 10px;
  }
  .mb40 {
    margin-bottom: 40px;
  }
  .ml20 {
    margin-left: 20px;
  }
  .w300 {
    width: 300px;
  }

  .risks-block {
    display: flex;
    justify-content: flex-start;
    align-items: flex-start;
    padding-top: 8px;
    &__item {
      width: 50%;
    }
    &__title {
      @include font-mixin(12px, 12px, 400, $color-grey-label , 0.4px);
    }
    &__body {
      display: flex;
      justify-content: flex-start;
      align-items: center;
      margin-top: 4px;
      min-height: 21px;
      .icons {
        &:not(:empty) {
          margin-right: 7px;
        }
        .icon {
          position: relative;
          font-size: 22px;
          & + .icon {
            margin-left: -10px;
          }
          &:nth-child(1) {
            z-index: 6;
          }
          &:nth-child(2) {
            z-index: 5;
          }
          &:nth-child(3) {
            z-index: 4;
          }
          &:nth-child(4) {
            z-index: 3;
          }
        }
      }
      span {
        @include font-mixin(12px, 12px, 400, $color-text-base , 0.4px);
      }
    }
  }

  .table-block {
    border-style: solid;
    border-color: $lavender;
    border-width: 1px 1px 0 1px;
    border-radius: 3px;
    &__header {
      display: flex;
      align-items: center;
      height: 60px;
      padding: 0 20px;
      background-color: $background-color-light;
      @include font-mixin(12px, 12px, 400, $color-text-base , 0.2px);
      .icon {
        margin-right: 8px;
        font-size: 13px;
        color: $color-grey-span;
      }
      span {
        margin-left: 8px;
        margin-right: 8px;
      }
    }
    &::v-deep {
      table {
        min-width: auto;
      }
    }
  }

  .services-block {
    padding: 10px 20px;
    border: 1px solid $lavender;
    border-radius: 3px;
  }

  &::v-deep {
    .ob-selector__multi-select {
      margin-bottom: 0;
    }
    .ob-selector__dropdown-control-open {
      display: none;
    }

    .table-footer {
      display: none;
    }
  }

  .order-step__misc-item {
    padding: 0 10px;
    display: flex;
    align-items: center;
    height: 40px;
    background-color: $light-lavender;
    border-bottom: 1px solid $components-orderItem_order_step_misc_item_border-bottom;
    border-top: 1px solid $light-lavender;
    cursor: pointer;
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
    button {
      display: flex;
      align-items: center;
      margin-right: 8px;
      margin-top: 1px;
      border: none;
      outline: none;
      background-color: transparent;
      appearance: none;
      font-size: 16px;
      color: $color-blue-navy-blue;
      transition: all 0.2s ease-in-out;
      @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);

      .icon {
        display: inline-block;
        transform: rotate(180deg);
        font-size: 26px;
      }
    }

    & > span {
      margin-top: 1px;
    }

    .closed .icon {
      transform: rotate(90deg);
    }
  }

  .accordeon-content {
    margin-top: 40px;
    margin-bottom: 60px;
  }

  &::v-deep {
    .not-api {
      box-shadow: 0 0 5px $components-orderItem_not_api_box_shadow;
    }
  }

  .link-style {
    color: $color-blue-navy-blue;
    text-decoration: none;
  }

  .corrections-info {
    padding-top: 30px;
    text-align: center;
    &__title {
      @include font-mixin(20px, 28px, 700, $color-text-base, 0.4px);
    }
    p {
      margin-top: 20px;
      @include font-mixin(16px, 20px, 400);
    }
  }
}

.not-api {
  box-shadow: 0 0 5px $components-not_api_box_shadow;
}
</style>
